AiStaffo

QR Code Generator

This free QR code generator makes static QR codes: the content is written straight into the code, so it never expires, needs no sign-up and has no tracking or redirect in between. Choose a type (link, Wi-Fi, contact card, WhatsApp, UPI payment and more), fill in the details, then download a PNG or SVG ready to print.

What should the QR code do?
Design options: size, colours, logo

What each type puts inside the code

Website linkThe address itself, e.g. https://example.com/menu (https:// is added if you leave it out)
TextYour text exactly as typed, UTF-8 encoded (any language and emoji)
Wi-FiWIFI:T:WPA;S:network;P:password;; with \ ; , " and : escaped by a backslash
Contact (vCard)A vCard 3.0 contact card (RFC 2426): BEGIN:VCARD … END:VCARD
Emailmailto:address?subject=…&body=… (RFC 6068)
SMSSMSTO:+number:message, the form phone camera apps recognise
Phone calltel:+number (RFC 3966)
WhatsApphttps://wa.me/number?text=message (WhatsApp click-to-chat format)
UPI paymentupi://pay?pa=UPI-ID&pn=name&am=amount&cu=INR&tn=note (NPCI linking format)
Locationgeo:latitude,longitude (RFC 5870)

Static QR codes never expire

Many QR sites make "dynamic" codes: the code holds a short link to their server, which then redirects to your content. That lets them count scans, but the code stops working if the subscription ends or the service closes. The codes made here are static. Your link, Wi-Fi details or contact card sit inside the code itself, so the code works for as long as the content is valid, with no account, no fees and no tracking. To count visits from a printed code, add campaign tags to your own link (for example ?utm_source=flyer) and read them in your website analytics.

Size, colours and logos that still scan

  • Contrast: keep a dark code on a light background. Light-on-dark codes and pale colours fail on many phones. The tool warns you below 4:1 contrast.
  • Quiet zone: the QR standard (ISO/IEC 18004) asks for a clear border 4 squares wide. Keep the margin at 4 unless the code sits on a plain white area.
  • Error correction: level L restores about 7% of a damaged code, M 15%, Q 25% and H 30%. Higher levels make the code denser. M suits most uses; use H for codes that get scuffed or carry a logo.
  • Logo: adding a logo switches to level H and covers about 5% of the code. Always test the downloaded file with a few different phones.
  • Print size: a common rule of thumb is at least 2 × 2 cm, and about one tenth of the scanning distance (a poster read from 3 m needs a code about 30 cm wide). Dense codes need more.
  • PNG or SVG: PNG for documents, social posts and office printers; SVG for designers and large prints, as it stays sharp at any size.

Worked example

A café wants a code for its menu page, https://example.com/menu. With error correction M, the code holds exactly https://example.com/menu. That is 24 characters, which fits in a version 2 code of 25 × 25 squares. At the default 1024 pixels with a 4-square margin, each square is about 31 pixels wide, plenty for print.

For businesses: what happens after the scan

A QR code starts a conversation: a menu order, a WhatsApp chat, a payment, an enquiry form. AiStaffo sets up AI workers that pick up from there, answering chats and enquiries, logging leads, matching payments to orders and sending follow-ups, so your team only handles the exceptions. Book a free automation audit to see which of these your business could hand over.

Please note: this generator follows the published formats as checked on 21 October 2026. How a phone reacts to a scanned code depends on its camera or scanner app, so test every code on more than one phone before printing it in quantity.

Questions people ask

Do these QR codes expire?
No. They are static codes: the content is inside the code, not on a server, so they keep working as long as the link, number or network they contain is still valid.
Is this QR code generator really free for business use?
Yes. There is no sign-up, no watermark and no limit, and you can print the codes on anything, including products and ads.
Can I track how many people scan my QR code?
Not with a static code, because nothing passes through a server. Add campaign tags to your link (for example ?utm_source=poster) and your website analytics will show the visits.
Can I change the content after printing?
No. A static code cannot be edited; make a new code. If you expect a link to change, point the code at a page on your own website that you can update.
What size should a printed QR code be?
At least 2 × 2 cm for a short link, and about one tenth of the scanning distance. Longer content makes a denser code that needs to be printed larger.
Why does my QR code not scan?
The usual causes are low contrast, a light code on a dark background, a missing white border, a logo covering too much, or printing too small. Fix these and test with more than one phone.

Book a free automation audit

Thirty minutes. We look at one process you run every week and tell you exactly what an AI worker would take off your desk, and what it would not.

We use these details only to reply to this request and prepare your audit, and keep them for up to two years. We send no marketing unless you tick the box above. Privacy policy